﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace NEW_MAP
{
    public partial class Form1 : Form
    {

        axGisToolKit.axMapPoint MouseXY = new axGisToolKit.axMapPoint();//компонент доступа к координатам векторной карты
        axGisToolKit.TxDoublePoint mypoint; //структура - точка метрики, аналогична с структурой Point 
        //count_out - счетчик масштабирования, связан с кнпкой уменьшить изображение
        //count_in - счетчик масштабирования связан с кнопкой увеличить изображение
        //map_scale - флаг масштабирования изображения, для отжатия кнопок
        //wmap - флаг открытия карты
        //ZoomMap - отвечает за масштабирование
        //PathShell - путь к приложению
        //ininame - путь к файлу panorama.ini
        //helpname - путь к файлу помощи panorama.chm
        // SelectRect - флаг выбора области на карте
        public int count_out = 0, count_in = 0, map_scale = 0, wmap = 0;
        public bool ZoomMap, SelectRect;
        public double xx, yy;
        public string PathShell, ininame, helpname;
        public TASKPARMEX param;

        public Form1()
        {
            InitializeComponent();
            // связывыаем компоненты с MapView1
            MapSelectDialog1.cMapView = MapView1.C_CONTAINER;
            MouseXY.cMapView = MapView1.C_CONTAINER;
            MapDataList1.cMapView = MapView1.C_CONTAINER;
            MapFind1.cMapView = MapView1.C_CONTAINER;
          
            MapFind1.cMapObj = MapObj1.C_CONTAINER;
            MapFind1.cMapObj = MapObjForSelect.C_CONTAINER;
            MapSelectRect1.cMapView = MapView1.C_CONTAINER;// выбор области

            MapObjForSelect.cMapView = MapView1.C_CONTAINER;// объект для выбора по области

            MapPoint1.cMapView = MapView1.C_CONTAINER;
            // задаем путь к приложения для ГИС ядра
            PathShell = Path.GetDirectoryName(Application.ExecutablePath) + "\\";
            GisProperty1.mapSetPathShell(PathShell);

            MapView1.PlaceOut = axGisToolKit.TxPPLACE.PP_PICTURE;// устанавливаем систему координат изобажения в пикселях
        }

        private void Taskparmex()
        {
            ininame = "C:\\Program Files(x86)\\Panorama\\Panorama Minix64\\panorama.ini";
            helpname = "C:\\Program Files(x86)\\Panorama\\Panorama Minix64\\panorama.chm";
            param = new TASKPARMEX();
            param.Init();
            param.Language = (int)axGisToolKit.TxMAPDLLLANGUAGE.ML_RUSSIAN;
            param.Handle = MapView1.MapHandle;
            param.IniName = Marshal.StringToHGlobalAnsi(ininame);
            param.HelpName = Marshal.StringToHGlobalAnsi(helpname);
            PathShell = Path.GetFullPath(Application.ExecutablePath + "\\");
            param.ApplicationName = Marshal.StringToHGlobalAnsi("GIS_PROJECT.EXE");
            param.PathShell = Marshal.StringToHGlobalAnsi(PathShell);
            param.Handle = (int)this.Handle;
            param.DocHandle = MapView1.MapHandle;


        }

       // код из прошлого приложения

        // общий поиск
        private void SearchDialog_Click(object sender, EventArgs e)
        {
            if (SearchDialog.Checked)
            {//деактивизируем систему поиска для очистки ранее найденных объектов
                if (MapFind1.Active)
                    MapFind1.Active = false;
                //открытие диалога выбора условий поиска
                if (MapSelectDialog1.Execute(MapFind1.cMapSelect, true))
                    if (MapSelectDialog1.ModalResult == 1)//найти
                    {
                        MapFind1.Active = true;
                        //перемещает объект в центр поля отображения
                        MapFind1.Center();
                        //диалог отображения данных о найденном объекте
                        MapObj1.ExecuteDlgFind(MapFind1.cMapSelect, false, 1);
                    }
                SearchDialog.CheckState = CheckState.Unchecked;
            }

        }

        // поиск по семантике
        private void SearchSemantic_Click(object sender, EventArgs e)
        {
            int semparam;
            Taskparmex();//инициализация структуры TASKPARMEX
            ARRAYNAME arname = new ARRAYNAME();
            arname.Init();//инициализация структуры ARRAYNAME

            //вызов функции поиска по названию
            semparam = Semantic_DLG.selSearchName(MapView1.MapHandle, MapFind1.MapSelectHandle, ref arname, ref param);

            if (semparam == 1)//найти 
            {
                MapFind1.Active = true;//активизируем систему поиска
                //перемещаем объект в центр поля отображения
                MapFind1.Center();
                //диалог отображения данных о найденном объекте
                MapObj1.ExecuteDlgFind(MapFind1.cMapSelect, false, 1);
            }

        }

        // поиск по области 
        private void SelectArea_Click(object sender, EventArgs e)
        {
            // Выбор области
            if (SelectArea.Checked)
                MapSelectRect1.StartAction();//включить режим выбора точки
            else MapSelectRect1.StopAction();
        }

        // продолжить поиск
        private void ContinueSearch_Click(object sender, EventArgs e)
        {
            MapObj1.ExecuteDlgFind(MapFind1.cMapSelect, true, 1);
            MapFind1.cMapObj.Center();
            ContinueSearch.CheckState = CheckState.Unchecked;
        }

        // добавлено выделение области 
        private void MapView1_OnMapMouseUp(object sender, AxaxGisToolKit.IaxMapViewEvents_OnMapMouseUpEvent e)
        {
            if (SelectArea.Checked)// если кнопка выбор области нажата
                SelectRect = true;//изменяем значение флага выделения области на карте
            else SelectRect = false;

            if (count_out > 0 && PlaceInMap.Checked)// если нажата кнопка уменьшения масштаба и счетчик увеличения масштаба>0
            {
                PlaceOutMap.CheckState = CheckState.Unchecked;// отжимаем кнопку увеличения масштаба
                count_out = 0;
            }
            else
            {
                if (count_in > 0 && PlaceOutMap.Checked)
                {
                    PlaceInMap.CheckState = CheckState.Unchecked;
                    count_in = 0;
                }
            }

            if (PlaceOutMap.Checked || PlaceInMap.Checked)//если нажата одна из кнопок масштабирования
                ZoomMap = true;//изменяем флаг масштабирования изображения
            else ZoomMap = false;

            if (ZoomMap == false && SelectRect == false)// если не масштабируем и не выбираем область
            {// выбрать объект карты по нажатию мыши 
                MapFind1.cMapObj.SelectObjectInPoint((int)e.x - MapView1.MapLeft, (int)e.y - MapView1.MapTop, 4, 0);
            }

            if (ZoomMap) // если активен режим масштабирования в точке нажатия
            {
                MouseXY.PlaceInp = axGisToolKit.TxPPLACE.PP_PICTURE; // устанавливаем систему координат на запись в пикселях

                mypoint.X = e.x;
                mypoint.Y = e.y;
                MouseXY.SetPoint(mypoint.X, mypoint.Y);// устанавливаем координаты точки метрики в системе заданной свойством PlaceIn

                // изменим масштаб
                // если нажата левая кнопка мыши
                if ((axGisToolKit.TxMouseButton)e.button == axGisToolKit.TxMouseButton.mbLeft)
                {
                    if (PlaceOutMap.Checked)//если нажата кнопка уменьшить масштаб 
                    {
                        MapView1.ViewScale = MapView1.ViewScale * 2;
                        MapView1.ScaleInPoint(MapView1.ViewScale, MouseXY.C_CONTAINER);

                        count_out++;//увеличиваем счетчик уменьшения изображения
                    }
                    else
                    {
                        if (PlaceInMap.Checked)//если нажаата кнопка увеличит масштаб
                        {
                            MapView1.ViewScale = MapView1.ViewScale / 2;
                            MapView1.ScaleInPoint(MapView1.ViewScale, MouseXY.C_CONTAINER);
                            count_in++;//увеличиваем счетчик увеличения изображения

                        }
                    }
                }
            }
            if (SelectRect) //если выбираем область
            {
                if (MapSelectRect1.Selection)//если область выбрана
                {
                    // Создать пустой объект
                    MapObjForSelect.CreateObjectByExcode(0, (int)axGisToolKit.TxMetricType.IDFLOAT2, 1000000005, (int)axGisToolKit.TxObjectLocal.OL_SQUARE);
                    // Установить метрику созданного объекта

                    MapSelectRect1.PPlace = axGisToolKit.TxPPLACE.PP_PLANE;
                    MapPoint1.PlaceInp = axGisToolKit.TxPPLACE.PP_PLANE;

                    axGisToolKit.TxDoublePoint mypoint;

                    mypoint.X = MapSelectRect1.SelectedRect.X1;
                    mypoint.Y = MapSelectRect1.SelectedRect.Y1;
                    MapPoint1.SetPoint(mypoint.X, mypoint.Y);

                    MapObjForSelect.Metric.Append(0, MapPoint1.C_CONTAINER);

                    mypoint.X = MapSelectRect1.SelectedRect.X1;
                    mypoint.Y = MapSelectRect1.SelectedRect.Y2;
                    MapPoint1.SetPoint(mypoint.X, mypoint.Y);

                    MapObjForSelect.Metric.Append(0, MapPoint1.C_CONTAINER);


                    mypoint.X = MapSelectRect1.SelectedRect.X2;
                    mypoint.Y = MapSelectRect1.SelectedRect.Y2;
                    MapPoint1.SetPoint(mypoint.X, mypoint.Y);

                    MapObjForSelect.Metric.Append(0, MapPoint1.C_CONTAINER);

                    mypoint.X = MapSelectRect1.SelectedRect.X2;
                    mypoint.Y = MapSelectRect1.SelectedRect.Y1;
                    MapPoint1.SetPoint(mypoint.X, mypoint.Y);

                    MapObjForSelect.Metric.Append(0, MapPoint1.C_CONTAINER);
                    MapObjForSelect.Commit();//записать изменение в карту
                    MapFind1.cMapSelect.SiteNumber = 0;   // основная карта
                    MapFind1.cMapSelect.UnselectSeekArea(-1);  // сбросим область если была
                    if (MapObjForSelect.Key == 0)//если ключ объекта 
                    {
                        MessageBox.Show("Объект не создан!");
                        return; // объекта карты нет
                    }

                    // установим область по созданному ранее объекту

                    MapFind1.cMapSelect.SelectSeekArea(-1, MapObjForSelect.C_CONTAINER, 0, 0, 2, 1, 0);

                    MapObjForSelect.Delete();
                    MapFind1.Active = true;
                    MapObjForSelect.ExecuteDlgFind(MapFind1.cMapSelect, false, 1);//вызов диалога перебора объектов найденных в выделенной области
                    MapSelectRect1.StopAction();
                    SelectArea.Checked = false;
                    MapView1.Repaint();

                }


            }
        }

     

       
    }
}
